# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.map_association import MapAssociation  # noqa: F401,E501


class MasterListEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'group_id': 'str',
        'concept_id': 'str',
        'mappings': 'list[MapAssociation]',
        'organisation': 'str',
        'request': 'bool',
        'code_list_ids': 'list[str]'
    }

    attribute_map = {
        'id': 'id',
        'group_id': 'groupId',
        'concept_id': 'conceptId',
        'mappings': 'mappings',
        'organisation': 'organisation',
        'request': 'request',
        'code_list_ids': 'codeListIds'
    }

    def __init__(self, id=None, group_id=None, concept_id=None, mappings=None, organisation=None, request=None, code_list_ids=None):  # noqa: E501
        """MasterListEntry - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._group_id = None
        self._concept_id = None
        self._mappings = None
        self._organisation = None
        self._request = None
        self._code_list_ids = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if group_id is not None:
            self.group_id = group_id
        self.concept_id = concept_id
        self.mappings = mappings
        self.organisation = organisation
        if request is not None:
            self.request = request
        if code_list_ids is not None:
            self.code_list_ids = code_list_ids

    @property
    def id(self):
        """Gets the id of this MasterListEntry.  # noqa: E501


        :return: The id of this MasterListEntry.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this MasterListEntry.


        :param id: The id of this MasterListEntry.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def group_id(self):
        """Gets the group_id of this MasterListEntry.  # noqa: E501


        :return: The group_id of this MasterListEntry.  # noqa: E501
        :rtype: str
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """Sets the group_id of this MasterListEntry.


        :param group_id: The group_id of this MasterListEntry.  # noqa: E501
        :type: str
        """

        self._group_id = group_id

    @property
    def concept_id(self):
        """Gets the concept_id of this MasterListEntry.  # noqa: E501


        :return: The concept_id of this MasterListEntry.  # noqa: E501
        :rtype: str
        """
        return self._concept_id

    @concept_id.setter
    def concept_id(self, concept_id):
        """Sets the concept_id of this MasterListEntry.


        :param concept_id: The concept_id of this MasterListEntry.  # noqa: E501
        :type: str
        """
        if concept_id is None:
            raise ValueError("Invalid value for `concept_id`, must not be `None`")  # noqa: E501

        self._concept_id = concept_id

    @property
    def mappings(self):
        """Gets the mappings of this MasterListEntry.  # noqa: E501


        :return: The mappings of this MasterListEntry.  # noqa: E501
        :rtype: list[MapAssociation]
        """
        return self._mappings

    @mappings.setter
    def mappings(self, mappings):
        """Sets the mappings of this MasterListEntry.


        :param mappings: The mappings of this MasterListEntry.  # noqa: E501
        :type: list[MapAssociation]
        """
        if mappings is None:
            raise ValueError("Invalid value for `mappings`, must not be `None`")  # noqa: E501

        self._mappings = mappings

    @property
    def organisation(self):
        """Gets the organisation of this MasterListEntry.  # noqa: E501


        :return: The organisation of this MasterListEntry.  # noqa: E501
        :rtype: str
        """
        return self._organisation

    @organisation.setter
    def organisation(self, organisation):
        """Sets the organisation of this MasterListEntry.


        :param organisation: The organisation of this MasterListEntry.  # noqa: E501
        :type: str
        """
        if organisation is None:
            raise ValueError("Invalid value for `organisation`, must not be `None`")  # noqa: E501

        self._organisation = organisation

    @property
    def request(self):
        """Gets the request of this MasterListEntry.  # noqa: E501


        :return: The request of this MasterListEntry.  # noqa: E501
        :rtype: bool
        """
        return self._request

    @request.setter
    def request(self, request):
        """Sets the request of this MasterListEntry.


        :param request: The request of this MasterListEntry.  # noqa: E501
        :type: bool
        """

        self._request = request

    @property
    def code_list_ids(self):
        """Gets the code_list_ids of this MasterListEntry.  # noqa: E501


        :return: The code_list_ids of this MasterListEntry.  # noqa: E501
        :rtype: list[str]
        """
        return self._code_list_ids

    @code_list_ids.setter
    def code_list_ids(self, code_list_ids):
        """Sets the code_list_ids of this MasterListEntry.


        :param code_list_ids: The code_list_ids of this MasterListEntry.  # noqa: E501
        :type: list[str]
        """

        self._code_list_ids = code_list_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MasterListEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
